<?php

/*
 * FAQ Manager Version 2
 * Copyright (c) 2002 Aquonics Scripting
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form.
 * This program is Freeware, please read the
 * license at http://www.aquonics.com/license.php
 *
 * Visit www.aquonics.com for more top scripts, free and custom.
 *
 * Authors: Stephen Ball <stephen@aquonics.com>
 *
 * Mar/2003: Modified to support Geeklog
 * Blaine Lang  geeklog@langfamily.ca
 */

$sql_log = array();     // An array to log the SQL queries
error_reporting(0);     // Turn off PHP's ugly error messages

// A nice function to help us die gracefully if there is an error including a file
function include_error($type)
{
    echo "<html>\r\n";
    echo "<title>Fatal Error</title>\r\n";
    echo "<body bgcolor=\"#FFFFFF\">\r\n";
    echo "<center><font face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" size=\"2\">There was an error loading the " . $type . " file.</font></center>\r\n";
    echo "</body>\r\n";
    echo "</html>";
}

if (!include("./data/settings.inc.php"))
{
    die(include_error("settings"));
}
else if (!include("./data/common.lib.php"))
{
    die(include_error("library"));
}
else if (!include("./data/stopwords.inc.php"))
{
    die(include_error("stopwords"));
}

// Geeklog Modification
require_once("../lib-common.php"); // Path to your lib-common.php
// Use Geeklog's Settings for the Database
$dbhost     = $_DB_host;
$dbuser     = $_DB_user;
$dbpass     = $_DB_pass;
$dbname     = $_DB_name;
$tbprefix   = $_DB_table_prefix . "faq";

if ($debug != 0)
{
    error_reporting($debug);
}

$starttime = starttime(); // Find out the microtime for the current time

// Get the variables from the user
$op		= param("op", "GET");
$c		= param("c", "GET");
$t		= param("t", "GET");

// Check to see if the user wants to view the SQL queries used
if ($sql == 2)
{
	$sql = param("sql", "GET");
}

$PHP_SELF = param("PHP_SELF", "SERVER");

$link_id = db_connect();
if (!$link_id)
{
    // Populate the MySQL error template
    $page = array("ERR_NUM" => $MYSQL_ERRNO, "ERR_MSG" => $MYSQL_ERROR);
    $data = template("./templates/mysql.tpl", $page);
    $pagetitle = "MySQL Server Error";
}
else
{
    if ($op == "cat")
    {
        // Display the category
        $name = query("SELECT name, description FROM " . $tbprefix . "_categories WHERE catID = '$c'");
        $check = mysql_num_rows($name);
        
        if ($check == 0)
        {
            // User is a dumb ass! This category doesn't exist!
            $pagetitle = "User Error";
            $cjump = generatecjump();
            $page = array("CAPTION" => $pagetitle, "MSG" => "You did not select a valid category", "INDEX" => $title, "THIS" => $pagetitle, "CAT_JUMP" => $cjump);
            $data = template("./templates/msg.tpl", $page);
        }
        else
        {
            $result = query("SELECT * FROM " . $tbprefix . "_topics WHERE catID = '$c' ORDER BY question");
            $total = mysql_num_rows($result);
            list($cat, $description) = mysql_fetch_row($name);
            $pagetitle = "Viewing Category";
            $cjump = generatecjump();

            if ($total == 0)
            {
                // There are no questions!
                $page = array("CAPTION" => $cat, "MSG" => "There are not any FAQ Topics in this category.", "INDEX" => $title, "THIS" => $cat, "CAT_JUMP" => $cjump);
                $data = template("./templates/msg.tpl", $page);       
            }
            else
            {
                // Display the questions
                $page = array("CAPTION" => $cat, "INDEX" => $title, "THIS" => $cat, "CAT_JUMP" => $cjump, "DESCRIPTION" => $description);
                $dynam = dynam_template("./templates/category.tpl", $page);

                $data = $dynam['top'];
                while ($query_data = mysql_fetch_array($result))
                {
                    $query_data['question'] = $query_data['question'];
                    $page = array("ID" => $query_data['topicID'], "QUESTION" => $query_data['question']);
                    $data .= parse_block($dynam['block'], $page);
                }
                $data .= $dynam['bottom'];
            }
        }
    }
    else if ($op == "view")
    {
        // Display the answer
        $result = query("SELECT * FROM " . $tbprefix . "_topics WHERE topicID = '$t'");
        list($topicID, $catID, $question, $answer) = mysql_fetch_row($result);
        $pagetitle = "Viewing Answer";

        $result2 = query("SELECT name FROM " . $tbprefix . "_categories WHERE catID = '$catID'");
        list($cat) = mysql_fetch_row($result2);

        $answer = str_replace("\r\n", "<br>", $answer);
        $answer = str_replace("\n", "<br>", $answer);

        $cjump = generatecjump();

        // Populate the Answer template
        $page = array("QUESTION" => $question, "ANSWER" => $answer, "CAT_ID" => $catID, "CAT_NAME" => $cat, "INDEX" => $title, "THIS" => $pagetitle, "CAT_JUMP" => $cjump, "PRINTER" => $PHP_SELF . "?op=print&t=" . $t);
        $data = template("./templates/answer.tpl", $page);
    }
    else if ($op == "print")
    {
        // Display the "printer friendly" page
        $result = query("SELECT * FROM " . $tbprefix . "_topics WHERE topicID = '$t'");
        list($topicID, $catID, $question, $answer) = mysql_fetch_row($result);
        $pagetitle = "Viewing Answer";

        $result2 = query("SELECT name FROM " . $tbprefix . "_categories WHERE catID = '$catID'");
        list($cat) = mysql_fetch_row($result2);

        $answer = str_replace("\r\n", "<br>", $answer);
        $answer = str_replace("\n", "<br>", $answer);

        // Populate the Answer template
        $page = array("TITLE" => "Printer Friendly View", "QUESTION" => $question, "ANSWER" => $answer, "CAT_ID" => $catID, "CAT_NAME" => $cat, "INDEX" => $title, "THIS" => $pagetitle);
        $data = template("./templates/printer.tpl", $page);
        mysql_close($link_id);
        echo $data;
        exit; // As soon as we have printed out the plain version quit so we don't get the global template parsed
    }
    else if ($op == "search")
    {
        // Display the search form
        $pagetitle = "Search FAQ Topics";
        $cjump = generatecjump();
        $page = array("CAT_JUMP" => $cjump, "INDEX" => $title, "THIS" => "Search", "ACTION" => $PHP_SELF);
        $data = template("./templates/search.tpl", $page);
    }
    else if ($op == "results")
    {
        // Collect and display the search results

        // Get the search variables
        $query	= param("query", "GET");
        $type	= param("type", "GET");

        if (empty($query))
        {
            // The variables haven't come from a get request so check 
            // to see if the user has modified the form to post them instead
            $query	= param("query", "POST");
            $type	= param("type", "POST");
        }

        // Define variables
        $query  = trim($query);
        $error  = 0;
        $word   = NULL;

        // Check to see if the user has entered a "stopword" or short word
        $parts = explode(" ", $query);
        foreach ($parts as $var)
        {
            if (in_array($var, $stopwords))
            {
                $error = 1;
                $word  = $var;
                break;
            }
            else if (strlen($var) <= 3)
            {
                $error = 2;
                $word  = $var;
                break;
            }
        }

        if (strlen($query) == 0)
        {
            // The user did not enter a query
            $page = array("MSG" => "You must enter a search query", "INDEX" => $title, "THIS" => "<a href=\"$PHP_SELF?op=search\">Search</a> &raquo; Error", "CAPTION" => "Search Error", "CAT_JUMP" => $cjump);
            $data = template("./templates/msg.tpl", $page); 
        }
        else if ($error == 1)
        {
            // The search contained a stopword
            $page = array("MSG" => "Sorry but the word &quot;" . $word . "&quot; is on the MySQL stoplist", "INDEX" => $title, "THIS" => "<a href=\"$PHP_SELF?op=search\">Search</a> &raquo; Error", "CAPTION" => "Search Error", "CAT_JUMP" => $cjump);
            $data = template("./templates/msg.tpl", $page);     
        }
        else if ($error == 2)
        {
            // The search contained a short word
            $page = array("MSG" => "Sorry but the word &quot;" . $word . "&quot; is is too short", "INDEX" => $title, "THIS" => "<a href=\"$PHP_SELF?op=search\">Search</a> &raquo; Error", "CAPTION" => "Search Error", "CAT_JUMP" => $cjump);
            $data = template("./templates/msg.tpl", $page);     
        }
        else 
        {
            if ($type == 1)
            {   
                // The user searched by keyword

                $result = query("SELECT topicID, question, keywords As Score FROM " . $tbprefix . "_topics WHERE MATCH (keywords) AGAINST ('" . $query . "') ORDER BY score");
            }
            else
            {
                // The user searched in the answer body
                $result = query("SELECT topicID, question, answer As Score FROM " . $tbprefix . "_topics WHERE MATCH (answer) AGAINST ('" . $query . "') ORDER BY score");
            }
        
            $found = mysql_num_rows($result);
            $cjump = generatecjump();
            $pagetitle = "Search Results";

            if ($found == 0 || $query == "")
            {
                // No matches found
                $page = array("INDEX" => $title, "CAT_JUMP" => $cjump);
                $data = template("./templates/noresult.tpl", $page);       
            }
            else
            {
                // Display the result
                $page = array("INDEX" => $title, "CAPTION" => "Search Results", "THIS" => "Search Results", "CAT_JUMP" => $cjump);
                $dynam = dynam_template("./templates/results.tpl", $page);

                $data = $dynam['top'];
                while ($query_data = mysql_fetch_array($result))
                {
                    $query_data['question'] = $query_data['question'];
                    $page = array("ID" => $query_data['topicID'], "QUESTION" => $query_data['question']);
                    $data .= parse_block($dynam['block'], $page);
                }
                $data .= $dynam['bottom'];
            }
        }
    }
    else
    {
        // Display the main page
        $result = query("SELECT * FROM " . $tbprefix . "_categories ORDER BY name");
        $total = mysql_num_rows($result);
        $pagetitle = $title;

        // Check to see if any categories have been created
        if ($total == 0)
        {
              $page = array("CAPTION" => "FAQ Categories", "MSG" => "You have yet to add any categories to FAQ Manager.", "INDEX" => $title, "THIS" => "Admin Error", "CAT_JUMP" => "");
              $data = template("./templates/msg.tpl", $page);
        }
        else
        {
            // Populate the Dynamic index template
            $dynam = dynam_template("./templates/index.tpl", array("CAPTION" => $title));

            $data = $dynam['top'];
            while ($query_data = mysql_fetch_array($result))
            {
                $query_data['name'] = $query_data['name'];
                $page = array("ID" => $query_data['catID'], "DESCRIPTION" => $query_data['description'], "CATEGORY" => $query_data['name'], "TOTAL" => $query_data['total']);
                $data .= parse_block($dynam['block'], $page);
            }
            $data .= $dynam['bottom'];
        }
    }

    mysql_close($link_id);
}

// Populate the query log
if ($sql == 1 && $sql_log[0] != "")
{
    // Display the questions
    $dynam = dynam_template("./templates/queries.tpl", array("CAPTION" => "Queries Used"));

    $queries = $dynam['top'];
    foreach ($sql_log as $log_entry)
    {
        $queries .= parse_block($dynam['block'], array("SQL" => htmlspecialchars($log_entry)));
    }
    $queries .= $dynam['bottom'];
}
else
{
    $queries = "";
}

$endtime = endtime($starttime);

// Populate the master template
$page = array("TITLE" => $pagetitle, "CONTENT" => $data, "STATS" => "This page took $endtime seconds to produce<br>Total queries to generate page: $QUERY_COUNT<br>GZIP Compression Status: " . $gzip, "VERSION" => $version, "QUERIES" => $queries);
$output = template("./templates/global.tpl", $page); // Finallise the template

// Evaluate the template to execute any PHP, make sure we break out of 
// PHP first, eval automatically returns back to PHP after it finishes 
// though, which is rather strange behaviour, maybe I have misunderstood eval completely
echo COM_siteHeader();
eval("?>" . $output);
echo COM_siteFooter();

?>